// measure speed of memory (best and worst case)
// System                 Array Min MaxMB/s Err ln2MinStep
// PM- 600MHz-1MB          16MB   52    364   16    12
// PM-1400MHz-1MB          16MB   50    364    8    12      valgrind=17MB/s
// Xeon-3GHz-1MB  2GB     256MB   39   1800   48    16   32bit-gcc-2.96  connect model=3 stepping=4  hdparm=800MB/s  busclock=200MHz
// Xeon-3GHz-2MB  2GB     256MB   44   2700   57    20   32bit-gcc-4.0.1 bb    model=4 stepping=3  hdparm=1472MB/s
// Xeon-3GHz-2MB 12GB     256MB   39   1422   31    20   64bit-gcc-4.1.1 morus model=4 stepping=10 memtest86+1.65=1257MB/s hdparm=1286MB/s
// Xeon-3GHz-2MB 12GB     512MB   38   1450   31    20   32bit-gcc-4.1.1-long morus model=4 stepping=10 memtest86+1.65=1257MB/s hdparm=1286MB/s
// Xeon-3GHz-2MB 12GB    8192MB   80   1170   23    19   64bit-gcc-4.1.1-long morus model=4 stepping=10 memtest86+1.65=1257MB/s hdparm=1286MB/s
// alpha-gs1280            16MB   15    215    6    14   (striped memory?)
// alpha-gs160-731MHz      16MB    6     59    2    13   load=12+1
// alpha-es45-1250MHz      16MB   87    818   20    11    4/5CPU
// DOpteron275-2.2GHz-1MB  16MB   35   1500   34    13   64bit-gcc-3.4.6      hdparm-T=1900MB/s
// DOpteron885-2.6GHz-1MB 256MB   38   1120   39    15   64bit-gcc-4.0.3      hdparm-T=1660MB/s
// DOpteron885-2.6GHz-1MB 512MB   68   2300   82    15   64bit-gcc-4.0.3-long hdparm-T=1660MB/s
// DOpteron885-2.6GHz-1MB 512MB*4 46   2220   77    15   CPU3-6! 64bit-gcc-4.0.3-long hdparm-T=1660MB/s
// altix330-IA64-It2-1500MHz      11    270    9    10   64bit-gcc-3.3.3      hdparm-T=3600MB/s
// altix330-IA64-It2-1500MHz      25    441   12    12   numactl -c 7 -m 7
// altix330-IA64-It2-1500MHz      10    239    7     9   numactl -c 7 -m 3
// altix330-IA64-It2-1500MHz      10    233    7     9   2*ueber-kreuz (7,3)
// SunFire880   1-2jobs           11    152    3    11   load=(6+1)/8
// MinMax fuer 2 Jobs etc.
// cpu.model=generation stepping=version (same masque)
//
#define ALen (1024*1024*4)  // 4M*int=4M*4=16MB
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
long int aa[ALen];

int main(){
  time_t t1,t2;
  long int loops,a,i,j,k,l,x=0;
  printf(" %d MB  int= %d\n",(ALen>>20)*sizeof(long int),sizeof(long int)*8);
  for (k=0;k<ALen;k++) { aa[k]=k; }
  for (a=0;a<24;a++) { // ln2 of look up steps
    loops=0;  
    t1=time(NULL);
    for (i=1;i<100000;i*=2) {
      for (j=0;j<i;j++) // repeat until some seconds are needed
         for (l=k=0;k<ALen;k++) { x^=aa[l]; l=(l+(1<<a)-1)%ALen; }
      loops+=i;
      t2=time(NULL);
      // printf(" step=1<<%3d loops=%8d time/s=%3d\n", a,loops,(int)(t2-t1));
      if (t2-t1>29) break;
    }
    printf(" step=1<< %3d loops= %8d time/s= %4d %8d kB/s +/- %4d\n",
       a,loops,(int)(t2-t1),
       (int)(ALen/1024*sizeof(long int)*loops/(t2-t1)  ),
       (int)(ALen/1024*sizeof(long int)*loops/(t2-t1-1)
            -ALen/1024*sizeof(long int)*loops/(t2-t1)  )  );
  }
  return x;
}
